<?php
namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Zeedhi\Framework\DTO\Response\Message;
use Teknisa\MAN\Services;
use Teknisa\MAN\Utilities;

class PrecoDifProd extends \Teknisa\MAN\Controllers\TeknisaCrud {
    
    protected $dataSourceName = 'vnd42407_cadautoprec';
    protected $parameterBagColumns = array('NRORG', 'CDFILIAL', '');
    protected $PrecoDifProdService;

    public function __construct ($crudService, $parameterBag, $entityManager, Services\PrecoDifProd $PrecoDifProdService) {
        $this->crudService              = $crudService;
        $this->parameterBag             = $parameterBag;
        $this->entityManager            = $entityManager;
        $this->PrecoDifProdService      = $PrecoDifProdService;
    }

    public function AutoPrecProd(DTO\Request $request, DTO\Response $response){
        $this->dataSourceName = 'vnd42407_cadautoprec';
        $row = $request->getRow();
        //remove dois pontos e pontos e define o consumidor
        $row['HRFINPRECDIA'] = str_replace(':', '', $row['HRFINPRECDIA']);
        $row['HRINIPRECDIA'] = str_replace(':', '', $row['HRINIPRECDIA']);
        $row['VRPRECODIA'] = str_replace(',', '.', $row['VRPRECODIA']);
        $row['CDTIPOCONSPD'] = $row['CDTIPOCONS'];
        //divide os dias para cada inserção.
        $DAYS = $row['NRDIASEMANPR'];
        $CDTABEPREC = $row['CDTABEPREC'];
        $CDFILIAL = $row['CDFILIAL'];
        
        $DTINIVGPREC = $row['DTINIVGPREC'];
        $DTFINVGPREC = $row['DTFINVGPREC'];
        $DTINIVALPREC = $row['DTINIVALPREC'];
        $DTFINVALPREC = $row['DTFINVALPREC'];
        
        if(Utilities\Util::formatDateToInteger($DTINIVGPREC) > Utilities\Util::formatDateToInteger($DTINIVALPREC) ||
           Utilities\Util::formatDateToInteger($DTINIVGPREC) > Utilities\Util::formatDateToInteger($DTFINVALPREC) ||
           Utilities\Util::formatDateToInteger($DTFINVGPREC) < Utilities\Util::formatDateToInteger($DTINIVALPREC) ||
           Utilities\Util::formatDateToInteger($DTFINVGPREC) < Utilities\Util::formatDateToInteger($DTFINVALPREC)){
           $response->addMessage(new Message("Data de validade fora do periódo de Vigência.",Message::TYPE_ERROR));
        }  else {
            $NRORG = $row['NRORG'];
            $CDARVPRODINI = $row['CDARVPRODINI'];
            if(!isset($row['CDARVPRODFINAL'])){
                $CDARVPRODFINAL = $row['CDARVPRODINI'];
            }else{
                $CDARVPRODFINAL = $row['CDARVPRODFINAL'];
            }
            $PRODLIST = $this->PrecoDifProdService->getProdPrecodia($CDARVPRODINI, $CDARVPRODFINAL, $CDTABEPREC, $CDFILIAL, $DTINIVGPREC, $NRORG);
            foreach ($PRODLIST as $CDPRODUTO) {
                $row['CDPRODUTO'] = $CDPRODUTO['CDPRODUTO'];
                $row['CDPRPAITABPR'] = $CDPRODUTO['CDPRODUTO'];
                foreach ($DAYS as $NRDIASEMANPR) {
                    $row['NRDIASEMANPR'] = $NRDIASEMANPR;
                    parent::save($request,$response);
                    $response->addMessage(new Message("Preço diferenciado adicionado com sucesso!",Message::TYPE_MESSAGE));
                 } 
            }
        }
    }
}