<?php

namespace Teknisa\MAN\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriterial;

class RestricaoProduto extends Crud{
   
   protected $dataSourceName = 'restricaoproduto';
   
   public function save(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $row = $request->getDataSet()->getRows()[0]; 
        
            $filterData = new \Zeedhi\Framework\DataSource\FilterCriteria('productgroup');
            $filterData->addCondition("CDARVPROD", \Zeedhi\Framework\DataSource\FilterCriteria::EQ , $row['CDARVPROD']);
            $filterData->setDataSourceName($this->dataSourceName);
            $dataSet = $this->dataSourceManager->findBy($filterData);
            
            if(count($dataSet->getRows()) > 0 && $row['__is_new']) {
                throw new \Exception('Essa combinação de códigos já existe no banco de dados');    
            }
            $dataSet = $request->getDataSet();
            
            $products = $row['PRODUTO_F'];
            foreach ($products as $prod) {
                
                $row['CDARVPROD'] = $prod;
                $row['PRODUTO_F'] = $prod;
                $row['CDPRODUTO'] = $prod;
                $dataSet->setDataSourceName($this->dataSourceName);
                $persistedRows = $this->dataSourceManager->persist($dataSet);
                $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
            }
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
   public function delete(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $deletedRows = $this->dataSourceManager->delete($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $deletedRows));
            $nrDeletedRows = count($deletedRows);
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
   
    public function saveQtdDiarias (DTO\Request\DataSet $request, DTO\Response $response){
        foreach ($request->getDataSet()->getRows() as &$row) {
            $row['QTCONSDIARAL'] = (float)$row['QTCONSDIARAL'];
            $row['QTCONSDIARAL_inline'] = $row['QTCONSDIARAL']; 
        }
        self::saveWithoutNotification($request,$response);
    }
    
    public function saveWithoutNotification(DTO\Request\DataSet $request, DTO\Response $response) {
        try {
            $dataSet = $request->getDataSet();
            $dataSet->setDataSourceName($this->dataSourceName);
            $persistedRows = $this->dataSourceManager->persist($dataSet);
            $response->addDataSet(new DataSet($this->dataSourceName, $persistedRows));
        } catch (\Exception $e) {
            $response->setCriticalError(new DTO\Response\Error($e->getMessage(), $e->getCode(), $e->getTraceAsString()));
        }
    }
}
